Page MenuHomePhabricator

Add `cluster.addresses` and require membership before accepting cluster authentication tokens
ClosedPublic

Authored by epriestley on Jan 2 2015, 9:13 PM.
Tags
None
Referenced Files
Unknown Object (File)
Fri, Feb 16, 8:51 AM
Unknown Object (File)
Thu, Feb 15, 6:33 AM
Unknown Object (File)
Wed, Feb 14, 11:53 PM
Unknown Object (File)
Sat, Feb 3, 1:42 AM
Unknown Object (File)
Thu, Feb 1, 5:32 AM
Unknown Object (File)
Jan 12 2024, 4:31 AM
Unknown Object (File)
Dec 26 2023, 3:48 AM
Unknown Object (File)
Dec 23 2023, 10:38 PM
Subscribers

Details

Summary

Ref T2783. Ref T6706.

  • Add cluster.addresses. This is a whitelist of CIDR blocks which define cluster hosts.
  • When we recieve a request that has a cluster-based authentication token, require the cluster to be configured and require the remote address to be a cluster member before we accept it.
    • This provides a general layer of security for these mechanisms.
    • In particular, it means they do not work by default on unconfigured hosts.
  • When cluster addresses are configured, and we receive a request to an address not on the list, reject it.
    • This provides a general layer of security for getting the Ops side of cluster configuration correct.
    • If cluster nodes have public IPs and are listening on them, we'll reject requests.
    • Basically, this means that any requests which bypass the LB get rejected.
Test Plan
  • With addresses not configured, tried to make requests; rejected for using a cluster auth mechanism.
  • With addresses configred wrong, tried to make requests; rejected for sending from (or to) an address outside of the cluster.
  • With addresses configured correctly, made valid requests.

Diff Detail

Repository
rP Phabricator
Lint
Lint Not Applicable
Unit
Tests Not Applicable